from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..types import UNSET, Unset

T = TypeVar("T", bound="PoolService_CoverageCheckResponse_200ResponsesItem")


@attr.s(auto_attribs=True)
class PoolService_CoverageCheckResponse_200ResponsesItem:
    """  """

    cusip: Union[Unset, str] = UNSET
    covered: Union[Unset, bool] = UNSET
    reasons: Union[Unset, List[str]] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        cusip = self.cusip
        covered = self.covered
        reasons: Union[Unset, List[Any]] = UNSET
        if not isinstance(self.reasons, Unset):
            reasons = self.reasons

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if cusip is not UNSET:
            field_dict["CUSIP"] = cusip
        if covered is not UNSET:
            field_dict["covered"] = covered
        if reasons is not UNSET:
            field_dict["reasons"] = reasons

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        cusip = d.pop("CUSIP", UNSET)

        covered = d.pop("covered", UNSET)

        reasons = cast(List[str], d.pop("reasons", UNSET))

        pool_service_coverage_check_response_200_responses_item = cls(
            cusip=cusip,
            covered=covered,
            reasons=reasons,
        )

        pool_service_coverage_check_response_200_responses_item.additional_properties = (
            d
        )
        return pool_service_coverage_check_response_200_responses_item

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
