from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..models.pool_service_get_distributions_response_200_distributions_item_originations_item import (
    PoolService_GetDistributionsResponse_200DistributionsItemOriginationsItem,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="PoolService_GetDistributionsResponse_200DistributionsItem")


@attr.s(auto_attribs=True)
class PoolService_GetDistributionsResponse_200DistributionsItem:
    """ Pool Allocations """

    cusip: Union[Unset, str] = UNSET
    originations: Union[
        Unset,
        List[PoolService_GetDistributionsResponse_200DistributionsItemOriginationsItem],
    ] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        cusip = self.cusip
        originations: Union[Unset, List[Any]] = UNSET
        if not isinstance(self.originations, Unset):
            originations = []
            for originations_item_data in self.originations:
                originations_item = originations_item_data.to_dict()

                originations.append(originations_item)

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if cusip is not UNSET:
            field_dict["CUSIP"] = cusip
        if originations is not UNSET:
            field_dict["originations"] = originations

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        cusip = d.pop("CUSIP", UNSET)

        originations = []
        _originations = d.pop("originations", UNSET)
        for originations_item_data in _originations or []:
            originations_item = PoolService_GetDistributionsResponse_200DistributionsItemOriginationsItem.from_dict(
                originations_item_data
            )

            originations.append(originations_item)

        pool_service_get_distributions_response_200_distributions_item = cls(
            cusip=cusip,
            originations=originations,
        )

        pool_service_get_distributions_response_200_distributions_item.additional_properties = (
            d
        )
        return pool_service_get_distributions_response_200_distributions_item

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
