from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..models.pool_prepayment_date import PoolPrepaymentDate
from ..types import UNSET, Unset

T = TypeVar(
    "T",
    bound="PoolService_GetHistoricalPrepaymentsResponse_200PrepaymentsItemPerfsItem",
)


@attr.s(auto_attribs=True)
class PoolService_GetHistoricalPrepaymentsResponse_200PrepaymentsItemPerfsItem:
    """  """

    cpr: Union[Unset, float] = UNSET
    date: Union[PoolPrepaymentDate, Unset] = UNSET
    smm: Union[Unset, float] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        cpr = self.cpr
        date: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.date, Unset):
            date = self.date.to_dict()

        smm = self.smm

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if cpr is not UNSET:
            field_dict["cpr"] = cpr
        if date is not UNSET:
            field_dict["date"] = date
        if smm is not UNSET:
            field_dict["smm"] = smm

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        cpr = d.pop("cpr", UNSET)

        date: Union[PoolPrepaymentDate, Unset] = UNSET
        _date = d.pop("date", UNSET)
        if not isinstance(_date, Unset):
            date = PoolPrepaymentDate.from_dict(cast(Dict[str, Any], _date))

        smm = d.pop("smm", UNSET)

        pool_service_get_historical_prepayments_response_200_prepayments_item_perfs_item = cls(
            cpr=cpr,
            date=date,
            smm=smm,
        )

        pool_service_get_historical_prepayments_response_200_prepayments_item_perfs_item.additional_properties = (
            d
        )
        return pool_service_get_historical_prepayments_response_200_prepayments_item_perfs_item

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
