from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..models.pool_service_get_summaries_response_200_pool_summary_loan_purposes import (
    PoolService_GetSummariesResponse_200PoolSummaryLoanPurposes,
)
from ..models.pool_service_get_summaries_response_200_pool_summary_loans_occupancies import (
    PoolService_GetSummariesResponse_200PoolSummaryLoansOccupancies,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="PoolService_GetSummariesResponse_200PoolSummary")


@attr.s(auto_attribs=True)
class PoolService_GetSummariesResponse_200PoolSummary:
    """ Pool summary provides information about Purposes and Occupancy of the loans. """

    cusip: Union[Unset, str] = UNSET
    occupancy: Union[
        PoolService_GetSummariesResponse_200PoolSummaryLoansOccupancies, Unset
    ] = UNSET
    purpose: Union[
        PoolService_GetSummariesResponse_200PoolSummaryLoanPurposes, Unset
    ] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        cusip = self.cusip
        occupancy: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.occupancy, Unset):
            occupancy = self.occupancy.to_dict()

        purpose: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.purpose, Unset):
            purpose = self.purpose.to_dict()

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if cusip is not UNSET:
            field_dict["CUSIP"] = cusip
        if occupancy is not UNSET:
            field_dict["occupancy"] = occupancy
        if purpose is not UNSET:
            field_dict["purpose"] = purpose

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        cusip = d.pop("CUSIP", UNSET)

        occupancy: Union[
            PoolService_GetSummariesResponse_200PoolSummaryLoansOccupancies, Unset
        ] = UNSET
        _occupancy = d.pop("occupancy", UNSET)
        if not isinstance(_occupancy, Unset):
            occupancy = PoolService_GetSummariesResponse_200PoolSummaryLoansOccupancies.from_dict(
                cast(Dict[str, Any], _occupancy)
            )

        purpose: Union[
            PoolService_GetSummariesResponse_200PoolSummaryLoanPurposes, Unset
        ] = UNSET
        _purpose = d.pop("purpose", UNSET)
        if not isinstance(_purpose, Unset):
            purpose = (
                PoolService_GetSummariesResponse_200PoolSummaryLoanPurposes.from_dict(
                    cast(Dict[str, Any], _purpose)
                )
            )

        pool_service_get_summaries_response_200_pool_summary = cls(
            cusip=cusip,
            occupancy=occupancy,
            purpose=purpose,
        )

        pool_service_get_summaries_response_200_pool_summary.additional_properties = d
        return pool_service_get_summaries_response_200_pool_summary

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
