from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..types import UNSET, Unset

T = TypeVar(
    "T", bound="PoolService_GetSummariesResponse_200PoolSummaryLoansOccupancies"
)


@attr.s(auto_attribs=True)
class PoolService_GetSummariesResponse_200PoolSummaryLoansOccupancies:
    """ Occupancy of the loan. """

    percentage2nd_home: Union[Unset, float] = UNSET
    percentage_investor: Union[Unset, float] = UNSET
    percentage_owner: Union[Unset, float] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        percentage2nd_home = self.percentage2nd_home
        percentage_investor = self.percentage_investor
        percentage_owner = self.percentage_owner

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if percentage2nd_home is not UNSET:
            field_dict["percentage2ndHome"] = percentage2nd_home
        if percentage_investor is not UNSET:
            field_dict["percentageInvestor"] = percentage_investor
        if percentage_owner is not UNSET:
            field_dict["percentageOwner"] = percentage_owner

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        percentage2nd_home = d.pop("percentage2ndHome", UNSET)

        percentage_investor = d.pop("percentageInvestor", UNSET)

        percentage_owner = d.pop("percentageOwner", UNSET)

        pool_service_get_summaries_response_200_pool_summary_loans_occupancies = cls(
            percentage2nd_home=percentage2nd_home,
            percentage_investor=percentage_investor,
            percentage_owner=percentage_owner,
        )

        pool_service_get_summaries_response_200_pool_summary_loans_occupancies.additional_properties = (
            d
        )
        return pool_service_get_summaries_response_200_pool_summary_loans_occupancies

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
